<template>
  <div class="app-container">
    <!--筛选条件-->
    <div class="search-div">
      <el-form ref="selectForm" :inline="true" :model="listQuery" class="form-container">
        <el-row>
          <el-form-item class="selectForm-container-item" prop="keywords">
            <el-input v-model.trim="listQuery.keywords" placeholder="井编号" clearable />
          </el-form-item>
          <el-form-item v-if="operation" class="selectForm-container-item" prop="alarmType">
            <el-select v-model="listQuery.alarmType" placeholder="告警类型" clearable>
              <el-option
                v-for="item in alarmTypeList"
                :key="item.value"
                :label="item.name"
                :value="item.value"
              />
            </el-select>
          </el-form-item>
          <el-form-item class="selectForm-container-item" prop="alarmType">
            <el-select v-model="listQuery.alarmContentType" :disabled="alarmContentTypeList.length>0?false:true" placeholder="告警内容" clearable>
              <el-option
                v-for="item in alarmContentTypeList"
                :key="item.value"
                :label="item.name"
                :value="item.value"
              />
            </el-select>
          </el-form-item>
          <el-form-item class="selectForm-container-item" prop="beginTime">
            <el-date-picker
              v-model="timeRange"
              type="datetimerange"
              range-separator="至"
              value-format="yyyy-MM-dd HH:mm:ss"
              start-placeholder="报警开始时间"
              end-placeholder="报警结束时间"
            />
          </el-form-item>
          <el-button class="filter-item" type="primary" icon="el-icon-search" @click="search">
            搜索
          </el-button>
        </el-row>
      </el-form>
    </div>
    <!--查询结果Table显示-->
    <div>
      <el-row class="table-title">
        <el-col :span="6">
          <div class="title-header">
            <i class="el-icon-menu" />数据列表
          </div>
        </el-col>
        <el-col :span="12" :offset="6" class="edit_btns">
          <el-button v-if="hasPerm('/alarm/export')" :disabled="total===0" class="edit_btn" size="small" @click="batchExport">
            导出记录
          </el-button>
        </el-col>
      </el-row>
      <el-table v-loading="listLoading" :data="list" class="table" border @selection-change="handleSelectionChange">
        <el-table-column :index="indexMethod" align="center" type="index" />
        <el-table-column v-for="column in columns" :key="column.value" :label="column.text" :width="column.width" :align="column.align" show-overflow-tooltip>
          <template slot-scope="scope">
            <span v-if="column.type!='Button'&&!column.level" :class="column.class">{{ scope.row[column.value] }}</span>
            <span v-if="column.type!='Button'&&column.level" :class="column.class">{{ formatValue(scope.row[column.value]) }}</span>
            <el-button v-if="column.type=='Button'" type="text" @click="showWellDetail(scope.row)">
              {{ scope.row[column.value] }}
            </el-button>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" width="80">
          <template slot-scope="scope">
            <el-button type="text" @click="showJob(scope.row)">
              查看工单
            </el-button>
          </template>
        </el-table-column>
      </el-table>
    </div>
    <!--分页-->
    <div class="pagination-container">
      <el-pagination
        v-show="total>listQuery.limit"
        :current-page="listQuery.offset"
        :page-sizes="[20,30,50]"
        :page-size="listQuery.limit"
        :total="total"
        align="center"
        layout="total, sizes, prev, pager, next"
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
      />
    </div>
    <info-well v-show="wellShow" ref="wellInfo" />
  </div>
</template>

<script>
import infoWell from '@/views/wellManage/infoWell'
import { getAlarmList, batchExportAlarm, getAlarmType, getAlarmContentType } from '@/api/alarm/alarm'
let isFromDetail = false
import { isOperation } from '@/utils/permission'

export default {
  name: 'ListAlarmRecords',
  components: { infoWell },
  data() {
    return {
      listQuery: {
        keywords: '',
        alarmType: '',
        alarmContentType: '',
        beginTime: '',
        endTime: '',
        offset: 1,
        limit: 20,
        sort: '',
        order: ''
      }, // 筛选条件
      timeRange: [], // 时间范围
      columns: [
        {
          text: '井编号',
          value: 'wellCode',
          align: 'center',
          type: 'Button'
        },
        {
          text: '设备编号',
          value: 'devcode',
          align: 'center'
        },
        {
          text: '详细地址',
          value: 'position',
          align: 'center'
        },
        {
          text: '告警类型',
          value: 'alarmTypeName',
          align: 'center'
        },
        {
          text: '告警等级',
          value: 'alarmLevel',
          align: 'center',
          level: true
        },
        {
          text: '告警原因',
          value: 'alarmContentName',
          align: 'center'
        },
        {
          text: '告警数值',
          value: 'alarmValue',
          width: 90,
          align: 'center',
          class: 'warning'
        },
        {
          text: '权属单位',
          value: 'deptName',
          align: 'center'
        },
        {
          text: '告警时间',
          value: 'alarmTime',
          width: 170,
          align: 'center'
        }

      ], // 显示列
      multipleSelection: [], // 多选选中项
      list: [], // 列表数据
      total: 0, // 数据总数
      alarmTypeList: [], // 告警类型列表
      alarmContentTypeList: [], // 告警内容类型列表
      showAlarmType: true, // 是否显示告警类型下拉
      listLoading: true, // 加载动画
      fullscreenLoading: false, // 全屏加载动画
      wellShow: false, // 是否显示编辑框
      detailShow: false // 是否显示编辑框
    }
  },
  computed: {
    alarmType() {
      return this.listQuery.alarmType
    },
    operation() {
      return isOperation()
    }
  },
  watch: {
    alarmType(val) {
      this.listQuery.alarmContentType = ''
      if (val && val !== '') {
        this.fetchAlarmContentType()
      } else {
        this.alarmContentTypeList = []
      }
    },
    timeRange(val) {
      if (val && val.length > 0) {
        this.listQuery.beginTime = val[0]
        this.listQuery.endTime = val[1]
      } else {
        this.listQuery.beginTime = ''
        this.listQuery.endTime = ''
      }
    }
  },
  created() {
    this.fetchAlarmType() // 告警类型下拉菜单
    console.log('records created')
  },
  beforeRouteEnter(to, from, next) {
    if (from.name) {
      if (from.name.indexOf('DetailJob') === -1) {
        isFromDetail = false
      } else {
        isFromDetail = true
      }
    } else {
      isFromDetail = false
    }
    next()
  },
  mounted() {
    if (this.$route.query && this.$route.query.wellCode) {
      this.listQuery.keywords = this.$route.query.wellCode
      this.fetchData(false)
    } else {
      this.listQuery.keywords = ''
      this.listQuery.alarmType = ''
      this.listQuery.alarmContentType = ''
      this.listQuery.beginTime = ''
      this.listQuery.endTime = ''
      this.timeRange = []
      this.fetchData(false)
    }
  },
  activated() {
    console.log('alarmRecored actived')
    if (!isFromDetail) {
      if (this.$route.query && this.$route.query.wellCode) {
        this.listQuery.keywords = this.$route.query.wellCode
        this.fetchData(false)
      } else {
        this.listQuery.keywords = ''
        this.listQuery.alarmType = ''
        this.listQuery.alarmContentType = ''
        this.listQuery.beginTime = ''
        this.listQuery.endTime = ''
        this.timeRange = []
        this.fetchData(false)
      }
    }
  },
  methods: {
    // 显示井详情
    showWellDetail(row) {
      this.wellShow = true
      this.$refs.wellInfo.initDialog(row.wellId)
    },
    formatValue(cellValue) {
      if (cellValue === 1) {
        return '一级告警'
      } else if (cellValue === 2) {
        return '二级告警'
      } else if (cellValue === 3) {
        return '三级告警'
      } else {
        return '--'
      }
    },
    // 工单
    showJob(row) {
      const jobId = row.jobId
      this.$router.push({ path: '/detailJob/' + jobId, query: { jobId: jobId }})
    },
    // 批量导出
    batchExport() {
      // 全屏加载动画
      const loading = this.$loading({
        lock: true,
        text: '数据处理中,请稍后...',
        spinner: 'el-icon-loading',
        background: 'rgba(0, 0, 0, 0.7)'
      })
      batchExportAlarm(this.listQuery).then(res => {
        loading.close() // 关闭加载动画
        console.log('download===', res)
        const blob = new Blob([res.data])
        const downloadElement = document.createElement('a')
        const href = window.URL.createObjectURL(blob) // 创建下载的链接
        downloadElement.href = href
        downloadElement.download = `告警记录.xlsx` // 下载后文件名
        document.body.appendChild(downloadElement)
        downloadElement.click() // 点击下载
        document.body.removeChild(downloadElement) // 下载完成移除元素
        window.URL.revokeObjectURL(href) // 释放blob对象
      }).catch((res) => {
        loading.close()
        this.$message.error(res.message)
      })
    },
    // 查询数据
    search() {
      this.fetchData(false)
    },
    // 获取集中器数据
    fetchData(isNowPage = true) {
      this.listLoading = true
      if (!isNowPage) { // 是否显示当前页，否则跳转第一页
        this.listQuery.offset = 1
      }
      getAlarmList(this.listQuery).then(response => {
        this.list = response.data.rows
        this.total = parseInt(response.data.total)
        this.listLoading = false
      })
    },
    // 获取告警类型
    fetchAlarmType() {
      getAlarmType().then(response => {
        this.alarmTypeList = response.data
        if (!isOperation()) { // 如果不是管理员和运维人员
          this.showAlarmType = false
          this.listQuery.alarmType = '1'
        }
      })
    },
    // 获取告警内容类别
    fetchAlarmContentType() {
      this.alarmContentTypeList = []
      getAlarmContentType(this.listQuery.alarmType).then(response => {
        const supportDeviceTypes = this.$store.getters.deviceTypes
        for (const item of response.data.list) {
          if (supportDeviceTypes.indexOf(item.deviceType) !== -1) {
            this.alarmContentTypeList.push(item)
          }
        }
      })
    },
    indexMethod(index) {
      return this.listQuery.limit * (this.listQuery.offset - 1) + index + 1
    },
    // 改变页容量
    handleSizeChange(val) {
      this.listQuery.limit = val
      this.fetchData()
    },
    // 改变当前页
    handleCurrentChange(val) {
      this.listQuery.offset = val
      this.fetchData()
    },
    // 多选触发方法
    handleSelectionChange(val) {
      this.multipleSelection = val
    }
  }
}
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
  $tableTitleHeight:46px;
  .table{
    margin-bottom: 20px;
  }
  .pagination-container{
    margin-bottom: 50px;
  }
  .table-title{
    background-color:rgba(243, 243, 243, 1);
    height: $tableTitleHeight;
    .title-header{
      line-height:$tableTitleHeight;
      color: #606266;
      font-size: 15px;
      i{
        margin-left: 5px;
        margin-right: 5px;
      }
    }
  }
  .edit_btns{
    .edit_btn{
      float:right;
      margin:7px 3px;//为了需要居中显示margin-top和bottom要用$tableTitleHeight减去按钮原高度除以2
    }
  }
  .warning{
    color: red;
  }
</style>
